%{
//Lex generated scanner for input to Crowbar simulator
#include <iostream.h>
#include "interface.h"

token_data data;
%}

%%
(l(ow)?)|(h(igh)?)|(x)          {
                                 data.command = yytext[0];
                                 return ASSIGN_PIN;
                                }
o(ptical)?                      return ASSIGN_OPTICAL;
q(uit)?\n                       return QUIT;
p(rint)?                        return PRINT;
s(imulate)?                     return SIMULATE;
y(es)?\n                        return YES;
n(o)?\n                         return NO;
help\n                          return HELP;
[A-Za-z]([A-Za-z0-9]|_)*	{
                                 data.name = yytext; 
                                 return NAME;
                                }
("+"?)([1-9])([0-9])*           {
                                 data.ival = atoi(yytext);
                                 return POS_INT;
                                }
[ \t]	                        ;           //whitespace
^[ \t]*\n                       return END; //blank line              
"|".*\n                         return END; //comment
\n                              return END; //EOL
.                               {
                                 data.name = yytext;
	                         return ERROR; 
                                }
%%

main()
{
 token_type token;
 state_type current_state = START_STATE;

 current_state = next_state(token, data, current_state); 
 while(current_state != END_STATE)
  {
   token = (token_type)yylex(); //get next token from standard input with Lexer
   current_state = next_state(token, data, current_state); 
   //Parser implemented as a deterministic finite-state machine
   //Parser calls semantic analysis routines when syntactically
   //valid statements are found
   //Semantic routines call model functions to execute commands 
  } //while
 //loop until user quits
} //main




